SystemOrganization addCategory: #'Pier-OmniBrowser-Core'!
SystemOrganization addCategory: #'Pier-OmniBrowser-Nodes'!
SystemOrganization addCategory: #'Pier-OmniBrowser-Actors'!

OBActor subclass: #PRContextActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Actors'!

!PRContextActor methodsFor: 'public' stamp: 'lr 12/23/2005 15:20'!
actionForNode: aNode in: aContext
	^ OBAction
		label: aContext command name asLowercase , '...'
		buttonLabel: aContext command name asLowercase
		receiver: self selector: #runForNode:in:
		arguments: (Array with: aNode with: aContext).! !

!PRContextActor methodsFor: 'public' stamp: 'lr 12/22/2005 18:43'!
actionsForNode: aNode
	| context |
	context := aNode context.
	^ (context commands
		reject: [ :each | aNode model viewCommandClass = each ])
		collect: [ :each | self actionForNode: aNode in: (context command: each new) ].! !

!PRContextActor methodsFor: 'actions' stamp: 'lr 12/24/2005 12:19'!
displayForNode: aNode in: aContext
	| result |
	aContext command isQuick
		ifTrue: [ ^ self executeForNode: aNode in: aContext ].
	result := aContext command asMorph
		addButtons;
		addWindow;
		callInWorld.
	result isNil
		ifFalse: [ self executeForNode: aNode in: aContext ].! !

!PRContextActor methodsFor: 'actions' stamp: 'lr 12/23/2005 15:18'!
executeForNode: aNode in: aContext
	aNode holder context: (aContext command execute; answer).
	aContext command answer command isView
		ifFalse: [ self displayForNode: aNode in: aContext command answer ].
! !

!PRContextActor methodsFor: 'actions' stamp: 'lr 12/24/2005 12:14'!
runForNode: aNode in: aContext
	PRCurrentContext use: aNode holder during: [ self displayForNode: aNode in: aContext ].! !

OBActor subclass: #PRInspectActor
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Actors'!

!PRInspectActor methodsFor: 'accessing' stamp: 'lr 12/22/2005 18:34'!
actionsForNode: aClassNode
	^ Array 
		with: (OBAction
			label: 'inspect'
			buttonLabel: String new
			receiver: aClassNode model
			selector: #inspect
			arguments: Array new
			keystroke: $i
			icon: MenuIcons inspectIcon)
		with: (OBAction
			label: 'explore'
			buttonLabel: String new
			receiver: aClassNode model
			selector: #explore
			arguments: Array new
			keystroke: $e
			icon: MenuIcons inspectIcon).! !

OBBrowser subclass: #PRPierBrowser
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRPierBrowser class methodsFor: 'configuration' stamp: 'lr 11/17/2005 14:44'!
defaultMetagraph
	^ #pier! !

!PRPierBrowser class methodsFor: 'configuration' stamp: 'lr 12/22/2005 18:24'!
defaultRootNode
	^ PRRootNode on: PRKernel instances.! !

!PRPierBrowser class methodsFor: 'initializing' stamp: 'lr 11/17/2005 18:22'!
initialize
	self registerInToolsFlap; registerInWorldMenu.! !

!PRPierBrowser class methodsFor: 'configuration' stamp: 'lr 11/1/2005 23:11'!
optionalButtons
	^ #( 'edit' 'add'  'remove' 'move' 'copy' ).! !

!PRPierBrowser class methodsFor: 'initializing' stamp: 'lr 11/17/2005 18:19'!
registerInToolsFlap
	self environment at: #Flaps ifPresent: [ :class |
		class
			registerQuad: #( PRPierBrowser open 'Pier Browser' 'A browser to inspect your pier environment and its meta-descriptions.' ) forFlapNamed: 'Tools';
			replaceToolsFlap ].! !

!PRPierBrowser class methodsFor: 'initializing' stamp: 'lr 11/17/2005 14:42'!
registerInWorldMenu
	self environment at: #TheWorldMenu ifPresent: [ :class |
		class registerOpenCommand: (Array 
			with: 'Pier Browser' 
			with: (Array
				with: self
				with: #open)) ].! !

!PRPierBrowser class methodsFor: 'configuration' stamp: 'lr 11/17/2005 14:42'!
title
	^ 'Pier Browser'! !

!PRPierBrowser methodsFor: 'morphic' stamp: 'lr 4/17/2005 11:59'!
defaultBackgroundColor
	^ Color r: 0.151 g: 0.327 b: 0.720.! !

!PRPierBrowser methodsFor: 'morphic' stamp: 'lr 4/25/2005 08:44'!
defaultLabel
	^ super defaultLabel , ': ' , self root name.! !

MAElementMorph subclass: #PRStructureMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRStructureMorph methodsFor: 'private' stamp: 'lr 11/14/2005 21:05'!
buildMorphEditor
	^ (SimpleHierarchicalListMorph
		on: self
		list: #root
		selected: #selected
		changeSelected: #selected:
		menu: nil
		keystroke: nil)
			hResizing: #spaceFill;
			borderColor: #inset;
			borderWidth: 2;
			expandAll;
			yourself.! !

!PRStructureMorph methodsFor: 'accessing-dynamic' stamp: 'lr 11/17/2005 16:09'!
root
	^ Array with: (PRStructureItemWrapper with: self model context root).! !

!PRStructureMorph methodsFor: 'accessing' stamp: 'lr 11/17/2005 16:09'!
selected
	^ PRStructureItemWrapper with: self value.! !

!PRStructureMorph methodsFor: 'accessing' stamp: 'lr 11/14/2005 20:55'!
selected: aWrapper
	self value: (aWrapper ifNotNil: [ aWrapper item ]).
	self changed: #selected.! !

OBNode subclass: #PRWikiNode
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

PRWikiNode subclass: #PRDescriptionNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRDescriptionNode methodsFor: 'accessing-dynamic' stamp: 'lr 12/22/2005 18:21'!
children
	self model hasChildren
		ifFalse: [ ^ super children ].
	^ self model children 
		collect: [ :each | self class on: each ].! !

!PRDescriptionNode methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:58'!
name
	^ self model label.! !

PRWikiNode subclass: #PRKernelNode
	instanceVariableNames: 'context'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 12/22/2005 18:14'!
children
	^ Array with: (PRStructureNode on: self model root holder: self).! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 12/22/2005 18:08'!
context
	^ context! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 1/2/2006 12:10'!
context: aContext
	context := aContext! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 12/22/2005 18:27'!
model: aModel
	super model: aModel.
	self context: (PRContext kernel: aModel).! !

!PRKernelNode methodsFor: 'accessing' stamp: 'lr 4/25/2005 08:40'!
name
	^ self model name.! !

PRWikiNode subclass: #PRRootNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRRootNode methodsFor: 'accessing' stamp: 'lr 12/22/2005 18:02'!
children
	^ self model collect: [ :each | PRKernelNode on: each ].! !

!PRRootNode methodsFor: 'accessing' stamp: 'lr 12/22/2005 18:04'!
name
	^ 'Root'! !

PRWikiNode subclass: #PRStructureNode
	instanceVariableNames: 'holder'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Nodes'!

!PRStructureNode class methodsFor: 'instance creation' stamp: 'lr 12/24/2005 12:02'!
on: aModel holder: aHolder
	^ (self on: aModel)
		holder: aHolder;
		yourself.! !

!PRStructureNode methodsFor: 'accessing-dynamic' stamp: 'lr 12/22/2005 18:24'!
children
	self model hasChildren 
		ifFalse: [ ^ super children ].
	^ self model children
		collect: [ :each | self class on: each holder: self holder ].
! !

!PRStructureNode methodsFor: 'actions' stamp: 'lr 1/2/2006 12:00'!
clickLink: aLink
	aLink isInternal
		ifTrue: [ self context: (self context structure: aLink target) ]
		ifFalse: [
			WebBrowser default 
				ifNotNilDo: [ :browser | aLink url asUrl activate ] ].! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 12/22/2005 18:25'!
context
	^ self holder context structure: self model.! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 1/2/2006 12:08'!
context: aContext
	self holder context: aContext.! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 12/24/2005 16:21'!
holder
	^ holder! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 12/22/2005 18:18'!
holder: aHolder
	holder := aHolder! !

!PRStructureNode methodsFor: 'accessing-dynamic' stamp: 'lr 4/17/2005 11:59'!
name
	^ self model title.! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 1/2/2006 12:10'!
text
	self model hasDocument
		ifFalse: [ ^ super text ].
	^ PRTextDocumentWriter new
		action: (MessageSend
			receiver: self 
			selector: #clickLink:);
		write: self model document.! !

!PRStructureNode methodsFor: 'accessing' stamp: 'lr 12/22/2005 15:48'!
text: aString
	| editcontext |
	editcontext := self context command: model editCommandClass new.
	(editcontext isValid and: [ editcontext command respondsTo: #contents: ])
		ifFalse: [ ^ super text: aString ].
	editcontext command contents: aString; execute.
	^ true.! !

!PRWikiNode class methodsFor: 'instance creation' stamp: 'lr 12/22/2005 18:19'!
on: aModel
	^ self new
		model: aModel;
		yourself.! !

!PRWikiNode methodsFor: 'accessing' stamp: 'lr 4/26/2005 20:49'!
children
	^ Array new.! !

!PRWikiNode methodsFor: 'accessing' stamp: 'lr 11/17/2005 15:36'!
description
	^ Array with: (PRDescriptionNode on: self model description).! !

!PRWikiNode methodsFor: 'comparing' stamp: 'lr 4/25/2005 23:58'!
hash
	^ self model hash.! !

!PRWikiNode methodsFor: 'accessing' stamp: 'lr 4/17/2005 11:59'!
model
	^ model! !

!PRWikiNode methodsFor: 'accessing' stamp: 'lr 12/22/2005 18:19'!
model: aModel
	model := aModel! !

!PRWikiNode methodsFor: 'accessing' stamp: 'lr 11/14/2005 20:19'!
text
	^ self model printString.! !

!PRWikiNode methodsFor: 'comparing' stamp: 'lr 4/25/2005 23:58'!
= anObject
	^ self species = anObject species
		and: [ self model = anObject model ].! !

PRDocumentWriter subclass: #PRTextDocumentWriter
	instanceVariableNames: 'action'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRTextDocumentWriter methodsFor: 'accessing' stamp: 'lr 12/24/2005 15:58'!
action
	^ action ifNil: [ action := self defaultAction ]! !

!PRTextDocumentWriter methodsFor: 'accessing' stamp: 'lr 12/24/2005 15:58'!
action: aBlock
	action := aBlock! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 12/22/2005 15:35'!
anchorAttributesFor: anObject
	^ Array with: (TextColor color: Color darkGray).! !

!PRTextDocumentWriter methodsFor: 'private' stamp: 'lr 12/24/2005 15:58'!
defaultAction
	^ [ :value | value explore ].! !

!PRTextDocumentWriter methodsFor: 'private' stamp: 'lr 12/22/2005 14:37'!
defaultStream
	^ TextStream on: Text new.! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 12/22/2005 15:25'!
headerAttributesFor: anObject
	^ Array with: TextEmphasis bold.! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 1/2/2006 11:59'!
linkAttributesFor: anObject
	^ Array 
		with: (PluggableTextAttribute
			evalBlock: [ self action value: anObject ])
		with: (anObject isBroken
			ifTrue: [ TextColor color: (Color r: 0.5 g: 0.0 b: 0.0) ]
			ifFalse: [ TextColor color: (Color r: 0.0 g: 0.0 b: 0.5) ])
		with: TextEmphasis underlined.! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 12/22/2005 15:30'!
listAttributesFor: anObject
	^ Array with: (TextIndent tabs: 1).! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 12/22/2005 15:37'!
preformattedAttributeFor: anObject
	^ Array with: TextEmphasis italic.! !

!PRTextDocumentWriter methodsFor: 'configuration' stamp: 'lr 12/22/2005 15:36'!
smileyAttributesFor: anObject
	^ Array 
		with: (TextColor color: Color orange) 
		with: TextEmphasis bold.! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 12/22/2005 15:21'!
visitAnchor: anObject
	self 
		withAttributes: (self anchorAttributesFor: anObject)
		do: [ super visitAnchor: anObject ].! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 12/22/2005 15:21'!
visitHeader: anObject
	self 
		withAttributes: (self headerAttributesFor: anObject)
		do: [ super visitHeader: anObject ].! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 12/22/2005 15:22'!
visitLink: anObject
	self 
		withAttributes: (self linkAttributesFor: anObject)
		do: [ super visitLink: anObject ].! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 12/22/2005 15:28'!
visitOrderedList: anObject
	self 
		withAttributes: (self listAttributesFor: anObject)
		do: [ super visitOrderedList: anObject ].! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 12/22/2005 15:37'!
visitPreformatted: anObject
	self 
		withAttributes: (self preformattedAttributeFor: anObject)
		do: [ super visitPreformatted: anObject ].! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 12/22/2005 15:34'!
visitSmiley: anObject
	self 
		withAttributes: (self smileyAttributesFor: anObject)
		do: [ super visitSmiley: anObject ].! !

!PRTextDocumentWriter methodsFor: 'visiting-document' stamp: 'lr 12/22/2005 15:28'!
visitUnorderedList: anObject
	self 
		withAttributes: (self listAttributesFor: anObject)
		do: [ super visitUnorderedList: anObject ].! !

!PRTextDocumentWriter methodsFor: 'streaming' stamp: 'lr 12/22/2005 15:16'!
withAttributes: aCollection do: aBlock
	^ self stream withAttributes: aCollection do: aBlock.! !

ListItemWrapper subclass: #PRStructureItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-OmniBrowser-Core'!

!PRStructureItemWrapper methodsFor: 'converting' stamp: 'lr 11/14/2005 20:58'!
asString
	^ self item title.! !

!PRStructureItemWrapper methodsFor: 'accessing' stamp: 'lr 11/1/2005 22:57'!
contents
	^ self item children collect: [ :each | self class with: each ].! !

!PRStructureItemWrapper methodsFor: 'testing' stamp: 'lr 4/25/2005 22:39'!
hasContents
	^ self item hasChildren.! !

!PRStructureItemWrapper methodsFor: 'comparing' stamp: 'lr 11/14/2005 20:57'!
hash
	^ self item hash.! !

!PRStructureItemWrapper methodsFor: 'accessing' stamp: 'lr 4/25/2005 22:38'!
item
	^ item! !

!PRStructureItemWrapper methodsFor: 'comparing' stamp: 'lr 11/14/2005 20:57'!
= anObject
	^ self species = anObject species
		and: [ self item = anObject item ].! !

!OBMetagraph methodsFor: '*pier-omnibrowser' stamp: 'lr 12/22/2005 18:28'!
pier
	| root kernel structure description |
	root := OBMetaNode named: 'Root'.
	kernel := OBMetaNode named: 'Kernel'.
	structure := OBMetaNode named: 'Structure'.
	description := OBMetaNode named: 'Description'.
	root 
		childAt: #children put: kernel.
	kernel
		childAt: #children put: structure;
		addActor: PRInspectActor new.
	structure 
		childAt: #children put: structure;
		childAt: #description put: description;
		addActor: PRContextActor new;
		addActor: PRInspectActor new;
		filterClass: OBModalFilter.
	description
		childAt: #children put: description;
		childAt: #description put: description;
		addActor: PRInspectActor new;
		filterClass: OBModalFilter.
	^ root.! !
PRPierBrowser initialize!
